package org.blender.dna;

import java.io.IOException;
import org.cakelab.blender.io.block.Block;
import org.cakelab.blender.io.block.BlockTable;
import org.cakelab.blender.nio.CArrayFacade;
import org.cakelab.blender.nio.CFacade;
import org.cakelab.blender.nio.CMetaData;
import org.cakelab.blender.nio.CPointer;


/**
 * Generated facet for DNA struct type 'bArmatureSensor'.
 * 
 * <h3>Class Documentation</h3>
 * 
 */

@CMetaData(size32=136, size64=136)
public class bArmatureSensor extends CFacade {

	/**
	 * This is the sdna index of the struct bArmatureSensor.
	 * <p>
	 * It is required when allocating a new block to store data for bArmatureSensor.
	 * </p>
	 * @see {@link org.cakelab.blender.io.dna.internal.StructDNA}
	 * @see {@link org.cakelab.blender.io.block.BlockTable#allocate}
	 */
	public static final int __DNA__SDNA_INDEX = 267;

	/**
	 * Field descriptor (offset) for struct member 'posechannel'.
	 * <h3>Pointer Arithmetics</h3>
	 * <p>
	 * This is how you get a reference on the corresponding field in the struct:
	 * </p>
	 * <pre>
	 * bArmatureSensor barmaturesensor = ...;
	 * CPointer&lt;Object&gt; p = barmaturesensor.__dna__addressof(bArmatureSensor.__DNA__FIELD__posechannel);
	 * CPointer&lt;CArrayFacade&lt;Byte&gt;&gt; p_posechannel = p.cast(new Class[]{CArrayFacade.class, Byte.class});
	 * </pre>
	 * <h3>Metadata</h3>
	 * <ul>
	 * <li>Field: 'posechannel'</li>
	 * <li>Signature: 'char[64]'</li>
	 * <li>Actual Size (32bit/64bit): 64/64</li>
	 * </ul>
	 */
	public static final long[] __DNA__FIELD__posechannel = new long[]{0, 0};

	/**
	 * Field descriptor (offset) for struct member 'constraint'.
	 * <h3>Pointer Arithmetics</h3>
	 * <p>
	 * This is how you get a reference on the corresponding field in the struct:
	 * </p>
	 * <pre>
	 * bArmatureSensor barmaturesensor = ...;
	 * CPointer&lt;Object&gt; p = barmaturesensor.__dna__addressof(bArmatureSensor.__DNA__FIELD__constraint);
	 * CPointer&lt;CArrayFacade&lt;Byte&gt;&gt; p_constraint = p.cast(new Class[]{CArrayFacade.class, Byte.class});
	 * </pre>
	 * <h3>Metadata</h3>
	 * <ul>
	 * <li>Field: 'constraint'</li>
	 * <li>Signature: 'char[64]'</li>
	 * <li>Actual Size (32bit/64bit): 64/64</li>
	 * </ul>
	 */
	public static final long[] __DNA__FIELD__constraint = new long[]{64, 64};

	/**
	 * Field descriptor (offset) for struct member 'type'.
	 * <h3>Pointer Arithmetics</h3>
	 * <p>
	 * This is how you get a reference on the corresponding field in the struct:
	 * </p>
	 * <pre>
	 * bArmatureSensor barmaturesensor = ...;
	 * CPointer&lt;Object&gt; p = barmaturesensor.__dna__addressof(bArmatureSensor.__DNA__FIELD__type);
	 * CPointer&lt;Integer&gt; p_type = p.cast(new Class[]{Integer.class});
	 * </pre>
	 * <h3>Metadata</h3>
	 * <ul>
	 * <li>Field: 'type'</li>
	 * <li>Signature: 'int'</li>
	 * <li>Actual Size (32bit/64bit): 4/4</li>
	 * </ul>
	 */
	public static final long[] __DNA__FIELD__type = new long[]{128, 128};

	/**
	 * Field descriptor (offset) for struct member 'value'.
	 * <h3>Pointer Arithmetics</h3>
	 * <p>
	 * This is how you get a reference on the corresponding field in the struct:
	 * </p>
	 * <pre>
	 * bArmatureSensor barmaturesensor = ...;
	 * CPointer&lt;Object&gt; p = barmaturesensor.__dna__addressof(bArmatureSensor.__DNA__FIELD__value);
	 * CPointer&lt;Float&gt; p_value = p.cast(new Class[]{Float.class});
	 * </pre>
	 * <h3>Metadata</h3>
	 * <ul>
	 * <li>Field: 'value'</li>
	 * <li>Signature: 'float'</li>
	 * <li>Actual Size (32bit/64bit): 4/4</li>
	 * </ul>
	 */
	public static final long[] __DNA__FIELD__value = new long[]{132, 132};

	public bArmatureSensor(long __address, Block __block, BlockTable __blockTable) {
		super(__address, __block, __blockTable);
	}

	protected bArmatureSensor(bArmatureSensor that) {
		super(that.__io__address, that.__io__block, that.__io__blockTable);
	}

	/**
	 * Get method for struct member 'posechannel'.
	 * @see #__DNA__FIELD__posechannel
	 */
	
	public CArrayFacade<Byte> getPosechannel() throws IOException
	{
		Class<?>[] __dna__targetTypes = new Class[]{Byte.class};
		int[] __dna__dimensions = new int[]{
			64
		};
		if ((__io__pointersize == 8)) {
			return new CArrayFacade<Byte>(__io__address + 0, __dna__targetTypes, __dna__dimensions, __io__block, __io__blockTable);
		} else {
			return new CArrayFacade<Byte>(__io__address + 0, __dna__targetTypes, __dna__dimensions, __io__block, __io__blockTable);
		}
	}

	/**
	 * Set method for struct member 'posechannel'.
	 * @see #__DNA__FIELD__posechannel
	 */
	
	public void setPosechannel(CArrayFacade<Byte> posechannel) throws IOException
	{
		long __dna__offset;
		if ((__io__pointersize == 8)) {
			__dna__offset = 0;
		} else {
			__dna__offset = 0;
		}
		if (__io__equals(posechannel, __io__address + __dna__offset)) {
			return;
		} else if (__io__same__encoding(this, posechannel)) {
			__io__native__copy(__io__block, __io__address + __dna__offset, posechannel);
		} else {
			__io__generic__copy( getPosechannel(), posechannel);
		}
	}

	/**
	 * Get method for struct member 'constraint'.
	 * @see #__DNA__FIELD__constraint
	 */
	
	public CArrayFacade<Byte> getConstraint() throws IOException
	{
		Class<?>[] __dna__targetTypes = new Class[]{Byte.class};
		int[] __dna__dimensions = new int[]{
			64
		};
		if ((__io__pointersize == 8)) {
			return new CArrayFacade<Byte>(__io__address + 64, __dna__targetTypes, __dna__dimensions, __io__block, __io__blockTable);
		} else {
			return new CArrayFacade<Byte>(__io__address + 64, __dna__targetTypes, __dna__dimensions, __io__block, __io__blockTable);
		}
	}

	/**
	 * Set method for struct member 'constraint'.
	 * @see #__DNA__FIELD__constraint
	 */
	
	public void setConstraint(CArrayFacade<Byte> constraint) throws IOException
	{
		long __dna__offset;
		if ((__io__pointersize == 8)) {
			__dna__offset = 64;
		} else {
			__dna__offset = 64;
		}
		if (__io__equals(constraint, __io__address + __dna__offset)) {
			return;
		} else if (__io__same__encoding(this, constraint)) {
			__io__native__copy(__io__block, __io__address + __dna__offset, constraint);
		} else {
			__io__generic__copy( getConstraint(), constraint);
		}
	}

	/**
	 * Get method for struct member 'type'.
	 * @see #__DNA__FIELD__type
	 */
	
	public int getType() throws IOException
	{
		if ((__io__pointersize == 8)) {
			return __io__block.readInt(__io__address + 128);
		} else {
			return __io__block.readInt(__io__address + 128);
		}
	}

	/**
	 * Set method for struct member 'type'.
	 * @see #__DNA__FIELD__type
	 */
	
	public void setType(int type) throws IOException
	{
		if ((__io__pointersize == 8)) {
			__io__block.writeInt(__io__address + 128, type);
		} else {
			__io__block.writeInt(__io__address + 128, type);
		}
	}

	/**
	 * Get method for struct member 'value'.
	 * @see #__DNA__FIELD__value
	 */
	
	public float getValue() throws IOException
	{
		if ((__io__pointersize == 8)) {
			return __io__block.readFloat(__io__address + 132);
		} else {
			return __io__block.readFloat(__io__address + 132);
		}
	}

	/**
	 * Set method for struct member 'value'.
	 * @see #__DNA__FIELD__value
	 */
	
	public void setValue(float value) throws IOException
	{
		if ((__io__pointersize == 8)) {
			__io__block.writeFloat(__io__address + 132, value);
		} else {
			__io__block.writeFloat(__io__address + 132, value);
		}
	}

	/**
	 * Instantiates a pointer on this instance.
	 */
	public CPointer<bArmatureSensor> __io__addressof() {
		return new CPointer<bArmatureSensor>(__io__address, new Class[]{bArmatureSensor.class}, __io__block, __io__blockTable);
	}

}
